

Rel : Set -> Type
Rel A = A -> A -> Prop

Refl : (A : Set) -> Rel A -> Prop
Refl A (#) = (x : A) -> x # x

TotalOrder : (A : Set) -> Rel A -> Type
TotalOrder A R =
  { !refl     : A -> A
  ; !total    : Refl A R
  }

Ord : (A : Set) -> Type
Ord A =
  { !leq    : A -> A -> Prop
  ; !eq     : A
  ; !proofs : TotalOrder A leq
  }

invertOrd : (A : Set) -> Ord A -> Ord A
invertOrd A ordA =
  ( \x y -> ordA.leq y x
  , ordA.eq
  , (?, ?)
  )

foo : (A : Set) -> A -> A
foo = \A x -> let id : A -> A
		  id = \y -> y
	      in  id x
