
data (==) {A:Set}(a:A) : A -> Set where
  refl : a == a

data Nat : Set where
  zero	: Nat
  suc	: Nat -> Nat

(+) : Nat -> Nat -> Nat
0     + m = m
suc n + m = suc (n + m)

plus0 : (n:Nat) -> n + 0 == n
plus0 0	      = refl
plus0 (suc n) = rewrite plus0 n in refl

rewrite plus0

plusS : (n,m:Nat) -> n + suc m == suc (n + m)
plusS 0	      m = refl
plusS (suc n) m	= rewrite plusS n m in refl

rewrite plusS

