
-- # import Property

-- Our domain (of sets)
D : Set

-- membership
infix 12 <-
(<-) : D -> D -> Prop

-- subset
infix 12 <=
(<=) : D -> D -> Prop

introImp (P,Q : Prop) : (P -> Q) -> P ==> Q
introImp f = \ p -> f p

elimSub : (A,B,x:D) -> A <= B /\ x <- A ==> x <- B
introSub (A,B:D) : ((x:D) -> x <- A ==> x <- B) ==> A <= B

inter : D -> D -> D

axInter : (x,y,z:D) -> z <- inter x y <=> z <- x /\ z <- y

lemSubInter : (x,y,z:D) -> z <= inter x y <=> z <= x /\ z <= y
lemSubInter x y z =
 let
   rem1 : z <= inter x y ==> z <= x
   rem1 = introImp (\ h -> introSub ( \ t -> \ h1 ->
	    let rem11 : t <- z
                rem11 = fol-plugin(h,h1,elimSub)
	    in fol-plugin(axInter,h,h1,elimSub)))
   rem2 : z <= inter x y ==> z <= y
   rem2 = introImp (\ h -> introSub ( \ t -> \ h1 -> fol-plugin(axInter,h,h1,elimSub)))
   rem3 : z <= x /\ z <= y ==> z <= inter x y
   rem3 = introImp (\ h -> introSub ( \ t -> \ h1 -> fol-plugin(axInter,h,h1,elimSub)))
   foo = debug-plugin(rem3)
 in
  fol-plugin(rem1,rem2,rem3)

