
import Data.List
import System.Environment

wordsBy :: (a -> Bool) -> [a] -> [[a]]
wordsBy p xs = yesP xs
    where
	yesP xs = noP (dropWhile p xs)

	noP []	= []
	noP xs	= ys : yesP zs
	    where
		(ys,zs) = break p xs

reorder :: String -> String
reorder "" = ""
reorder s = (++".") $ unwords $ intersperse "|"
		    $ sort $ map unwords $ wordsBy ("|"==)
		    $ wordsBy (`elem` " .") s

main =
    do	[file] <- getArgs
	s <- readFile file
	putStr $ unlines $ map reorder $ lines s

